/***********************************************************************/
/* INSTDBUG                                                            */
/*                                                                     */
/* Purpose: To call the debug install utility DBUGINST with the        */
/*  the correct command line:                                          */
/*                                                                     */
/*   d:\devtools\os2tkt21\debug\dbuginst /Sd:\devtools\os2tk21\debug x */
/*                                                                     */
/*  Arguments: The installation drive and directory.                   */
/***********************************************************************/
/*                (C) Copyright IBM Corporation 1994                   */
/***********************************************************************/
parse arg BDrl CDr .
trace 'o'

call Initialize

if RxCaDD.OpType = 'REMOVE'
  then do
    call 'MessageBox' Ctl.!ProgName, 'Remove is not supported.  Add the application',
         'again to recreate the program object.'
    call 'CaDDExit'
    exit 0
  end  /* Do */


call UseDbugInst

call 'CaddComplete' 12
call 'CaddExit'
exit 0


UseDbugInst:
/****************************************************************/
/* Call the dbuginstall program with the appropriate parameters */
/****************************************************************/

CurDir = directory()
call directory CDr'devtools\os2tk21\debug'
'@dbuginst ' '/S'CDr'devtools\os2tk21\debug' BDrl
InstallRC = RC
call directory CurDir
if InstallRC <> 0 then
do
        if InstallRC = 3 then do
                call 'MessageBox' 'Kernel Mismatch', 'No Kernel Debugger available for the installed level of OS/2.  Unable to install the Kernel Debugger.'
                call 'CaddComplete' 12
        end
        else do
         call 'CaddComplete' 12
        end

      exit 0
  end
return

Initialize:
/*******************************************************************/
/* Load required REXXUTIL (part of 2.0) utilites and the required  */
/* RXUTILS (part of CORE and avail on OS2TOOLS) utilites           */
/* figure out which drive is the boot drive                        */
/*******************************************************************/
CurDir = directory()
call directory CDr'INSTALL'
call Rxfuncadd 'CADDINIT', 'RXCADD', 'CADDINIT'
signal on syntax
ver = 'CAddInit'()
signal off syntax
if abbrev(ver, 'ERROR:')
  then call syntax
return
