/***********************************************************************/
/* MAKEDSKS                                                            */
/*                                                                     */
/* Purpose: Build disks based on a data file with nice prompts for the */
/*          user.                                                      */
/*                                                                     */
/* Parameters: Filename:     File containing data fields for disks.    */
/***********************************************************************/
/*                (C) Copyright IBM Corporation 1994                   */
/***********************************************************************/
parse upper arg CDr filename Option .
trace 'o'
signal on halt
'@ECHO OFF'

call Initialize

if RxCaDD.OpType = 'REMOVE'
  then do
    call 'MessageBox' ProgName, 'Remove is not supported.  Add the application',
         'again to recreate the program object.'
    call 'CaDDExit'
    exit 0
  end  /* Do */

i = ''

if substr(filename, 1, 1) = '\' then
   filename = delstr(filename, 1, 1)

filename = CDR||filename
call ReadIt filename

Main:
call GetAppData 'stem.'
ProgName = stem.1
if pos('TITLE=', stem.1) <> 0 then
   ProgName = substr(stem.1, 7)
lines_per_page = 11
pages = (line.0 > lines_per_page)
up_ok = 0
down_ok = 0
current_page = 0
end = lines_per_page
current = 0
j = 0
Dirty = 0
All = 0
Quiet = (Option = '/A')
do until i='Q' | All
  All = (Quiet | All)
  done = 0
  if \Quiet then do
    'cls'
    say
    say 'Ŀ'
    say '                       The Developer Connection                             '
    say '                    Diskette Image Creation Utility                         '
    say '                  (C) Copyright IBM Corporation 1994                        '
    say 'Ĵ'
    say '     Filename     Description                                               '
    say ''

        up_ok = (current > 0) & pages
        down_ok = (((current_page + 1)*lines_per_page ) < line.0) & pages
        j = current
    do while j < end & j < line.0
      j = j + 1
      parse var line.j file'|'desc
      parse value reverse(file) with temp'\'.
      file = reverse(temp)
      say '' right(j,2)': 'Left(file,12)' 'left(desc,58)''
    end
    say 'Ĵ'

        if \up_ok
        then up_prompt = '         '
        else up_prompt = 'U:Page Up'

        if \down_ok
        then down_prompt = '          '
        else down_prompt = 'D:PageDown'


 say '   'up_prompt'         Q:Quit          A:Make All Disks   'down_prompt'          '
    say ''
        if \up_ok
        then up_prompt = ''
        else up_prompt = ', U to page up'

        if \down_ok
        then down_prompt = ''
        else down_prompt = ', D to page down'

    say 'Enter [1-'line.0', A for All, Q to Quit'||up_prompt||down_prompt||']'
    do until (i>=1 & i<=line.0) | i='Q' | i='A' | (i = 'D'&down_ok) | (i='U'&up_ok)
      i=translate(linein('stdin'))
    end
  end /* If */
  All = ((i = 'A') | Quiet)
  if i <> 'Q' & \Dirty & i <> 'D' & i <> 'U'
    then do
      disk = GetSource()
      Dirty = 1
    end /* Do */
  select
     when i = 'U' & up_ok
       then do
             current_page = current_page - 1
         current = current_page * lines_per_page
         end = current + lines_per_page
       end /* Do UP */
     when i = 'D' & down_ok
       then do
                 current_page = current_page + 1
                 current = current_page * lines_per_page
                 end = current + lines_per_page
       end /* Do */
     when \All & i <> 'Q' & \Quiet
       then do
                call MakeIt i disk
       end  /* Do */
     when All & \done
       then do
         num = 0
         do while All & \done
           num = num + 1
           call MakeIt num disk
           done = (num = line.0)
         end /* do */
       end /* Do */
     otherwise
       nop
  end  /* select */
  if( i = 'Q' ) then do
      call 'MessageBox' ProgName, 'Installation ended by user.'
      exit
  end
end /* Do */

if Quiet
  then do
    cls
    say 'Ŀ'
    say '                       The Developer Connection                             '
    say '                    Diskette Image Creation Utility                         '
    say '                  (C) Copyright IBM Corporation 1994                        '
    say 'Ĵ'
    say '                                                                            '
    say '  CD ROM redirected installation diskettes for OS/2 2.X have been created.  '
    say '        Insert the diskette labeled OS/2 Installation Diskette into         '
    say '                         drive A: and REBOOT NOW!!                          '
    say '                                                                            '
    say '    Warning: Please be sure to read the README.NOW file on the CD ROM.      '
    say ''
    'pause'
  end  /* Do */

call 'CaddComplete' 12
call 'CaddExit'
exit

Initialize:
CurDir = directory()
call directory CDr'INSTALL'
call Rxfuncadd 'CADDINIT', 'RXCADD', 'CADDINIT'
signal on syntax
ver = 'CAddInit'()
signal off syntax
if abbrev(ver, 'ERROR:')
  then call syntax
return

ReadIt: procedure expose line.
parse arg filename
size = stream(filename, 'C', 'QUERY SIZE')
if size = ''
  then do
    say
    say '  Cannot access data in 'filename'  Make sure filename is valid.'
    'pause'
    call 'CaddComplete' 2
    exit 2
  end  /* Do */
data = charin(filename, '1', size)
temp = stream(filename, 'C', 'CLOSE')

num  = 0
do while length(data) <> 0
  num = num + 1
  parse var data line.num'0d0a'x rest
  data = rest
end /* do */
line.0 = num
return

GetSource: procedure

'@ECHO OFF'
good = 0
drive = 'A:'
do until good
  'cls'
  drive = 'A:'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '                    Diskette Image Creation Utility                         '
  say '                  (C) Copyright IBM Corporation 1994                        '
  say ''
  say
  say '  Enter floppy drive letter to build diskettes (Default= A:):'
  tdrive = translate(linein(STDIN))
  call 'QueryDrive'
  if tdrive <> ''
    then do
      if right(tdrive,1) <> ':'
        then tdrive = tdrive':'
      drive = tdrive
    end /* Do */
        tdrive=left(drive,1)
  if pos(tdrive,rxcadd.floppy) <> '0'
    then do
      say '  You selected drive 'drive'.  Is this correct(Y/N)?'
        answer = translate(linein(STDIN))
      do while answer <> 'Y' & answer <> 'N'
        call beep 300, 150
        say '  Enter Y or N.'
        answer = translate(linein(STDIN))
      end /* do */
      if answer = 'Y'
        then good = 1
    end
    else do
      call beep 300, 150
      say '  Invalid floppy drive.'
      'pause'
    end /* do */
end /* Do */
return drive

MakeIt: procedure expose line. CDr filename
parse arg num disk
'@ECHO OFF'
retry = 1
parse var line.num file'|'desc
do until retry <> 0
  'cls'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '                    Diskette Image Creation Utility                         '
  say '                  (C) Copyright IBM Corporation 1994                        '
  say 'Ĵ'
  say '                                                                            '
  say ''center('Insert a formatted diskette into the 'Disk' drive.',76)''
  say '                                                                            '
  say ''center(desc,76)''
  say '                                                                            '
  say '             Press [M] then [ENTER] to go back to the main menu.            '
  say '             or [ENTER] to build the diskette.                              '
  say ''
  answer = 'Q'
  do until answer = ''
    answer = translate(linein(STDIN))
    if answer = 'M' then signal Main
  end /* do */
  do while queued() <> 0
    pull .
  end /* do */
  do while stream(Disk'\', 'C', 'Query Size') = ''
    call beep 300, 150
    say 'Ŀ'
    say '    'left('Unable to access disk in drive 'Disk, 72)''
    say '    The drive may be empty or the disk is unreadable.                       '
    say '                                                                            '
    say '    Insert a disk into the drive and press [ENTER] to type [Q] to Quit      '
    say ''
    answer = 'NOVALUE'
    do while answer <> 'Q' & answer <> ''
      answer = translate(linein(STDIN))
    end /* do */
    if answer = 'Q' then signal Main
  end /* do */
  say 'Ŀ'
  say '            Creating disk.  Be patient, this may take a few minutes...      '
  say ''
  CDr'INSTALL\LOADDSKF' CDr||file Disk '/F /Y /Q |RXQUEUE'
  do while queued() <> 0
    parse upper pull line
    if line <> '' then Resp = line
  end /* do */
  select
     when Resp = 'DISK CREATED SUCCESSFULLY'||x2c(07)
       then do
         call beep 500,150
         retry = 1
       end
     when Resp = 'ERROR WHILE OPENING THE FILE'
       then do
         call beep 300, 150
         say 'Ŀ'
         say '    Unpack failed:  Diskimage file could not be opened.                     '
         say '                    Ensure that the correct CD ROM is inserted              '
         say '                    and can be accessed by the system.                      '
         say '                                                                            '
         say '  Hit [M] for Main Menu, [R] to Try again  or [S] to Skip to the next disk  '
         say ''
         resp = GetMessage()
         if resp = 1 then signal main
         if resp = 0 then retry = 0
         else return 0
       end  /* Do */
     when Resp = 'CANNOT FORMAT TARGET DISK'
       then do
         call beep 300, 150
         say 'Ŀ'
         say '    Unpack failed:  Diskette is WRITE PROTECTED or DEFECTIVE.               '
         say '                    Try another diskette or remove the write protect tab.   '
         say '                                                                            '
         say '  Hit [M] for Main Menu, [R] to Try again  or [S] to Skip to the next disk  '
         say ''
         resp = GetMessage()
         if resp = 1 then signal main
         if resp = 0 then retry = 0
         else return 0
       end  /* Do */
     when Resp = 'ERROR WHILE WRITING THE DISK DATA'
       then do
         call beep 300, 150
         say 'Ŀ'
         say '    Unpack failed:  Error occurred while writing the disk data.             '
         say '                                                                            '
         say '  Hit [M] for Main Menu, [R] to Try again  or [S] to Skip to the next disk  '
         say ''
         resp = GetMessage()
         if resp = 1 then signal main
         if resp = 0 then retry = 0
         else return 0
       end  /* Do */
     otherwise do
       call beep 500,150
       retry = 0
     end /* Otherwise */
  end  /* select */
end /* Do */

'cls'
say
say 'Ŀ'
say '                       The Developer Connection                             '
say '                    Diskette Image Creation Utility                         '
say '                  (C) Copyright IBM Corporation 1994                        '
say 'Ĵ'
say '                                                                            '
say '             Remove the diskette from drive 'Disk' and label it:                '
say '                                                                            '
say ''center(desc,76)''
say '                                                                            '
say ''
'pause'
return Resp

GetMessage: procedure
Do until answer = 'M' | answer = 'R' | answer = 'S'
  answer = translate(linein(STDIN))
end /* Do */

if answer = 'M' then resp = 1
if answer = 'R' then resp = 0
if answer = 'S' then resp = 2
return resp

Syntax:
call beep 350, 150
say
say 'Ŀ'
say '  Dot not found in LIBPATH.  A dot will be automatically added to your  '
say '  CONFIG.SYS LIBPATH entry.  The DOT is necessary for the installation  '
say '  to find its DLL files in the current directory.                       '
say ''
'@echo off'
'call LIBADD . 'Ctl.!BDr'\CONFIG.SYS >nul 2>nul'
Resp = rc
if rc = 0
  then do
    call beep 350, 150
    say
    say 'Ŀ'
    say '                 REBOOT the system and try install again.               '
    say ''
  end
  else do
    call beep 350, 150
    say
    say 'Ŀ'
    say '   Unable to update CONFIG.SYS please do so manually then REBOOT.       '
    say ''
  end /* Do */
call 'CaddComplete' 200
exit 200

halt:

 say 'Ŀ'
 say '                   Disk creation aborted by the user.                       '
 say '                        Press [ENTER] to exit.                              '
 say ''
 'pause'
exit
