/***********************************************************************/
/* RUNPROG                                                             */
/*                                                                     */
/* Purpose: Uses XCOPY to install all files from a sub directory       */
/*          into a user specified destination directory.               */
/*                                                                     */
/* Parameters: BootDrive: Drive letter where system boots              */
/*             Install Drive: Drive letter and path of CDROM           */
/*             Program Name: fully qualified Name of the program to run*/
/*             Flag:    parameter for the program.                     */
/***********************************************************************/
/*                (C) Copyright IBM Corporation 1994                   */
/***********************************************************************/
parse upper arg Ctl.!BDr Ctl.!CDr Ctl.!ProgName Ctl.!RunProgName Ctl.!flag
trace 'o'
call on halt
Globals = 'Ctl.' 'RXCADD.'

call Initialize

if RxCaDD.OpType = 'REMOVE'
  then do
    call 'MessageBox' Ctl.!ProgName, 'Remove is not supported.  Add the application',
         'again to recreate the program object.'
    call 'CaDDExit'
    exit 0
  end  /* Do */

if substr(Ctl.!BDr,2, 1) <> ':' | substr(Ctl.!CDr,2, 1) <> ':'
  then call MyExit 302
Ctl.!CurDir = directory()
call directory(Ctl.!CurDir)
call RunProgram

call 'CaddComplete' 12
call 'CaddExit'

call MyExit 0
exit

Initialize: procedure expose (Globals)
CurDir = directory()
call directory Ctl.!CDr'INSTALL'
call Rxfuncadd 'CADDINIT', 'RXCADD', 'CADDINIT'
ver = 'CAddInit'()
/* Ctl.!Quiet = (wordpos('/N', Ctl.!Options) <> 0) */
return 0


RunProgram: procedure expose (Globals)
'@ECHO OFF'
value = ' '
SSND='SSND'
MMPM21TK='MMPM21TK'
ULTIMOT='ULTIMOT'
REALIZER='REALIZER'
CSETFIXC='CSETFIXC'
CSETFIXL='CSETFIXL'
CSETFIXU='CSETFIXU'
CSETFXCD='CSETFXCD'
CSETFXLD='CSETFXLD'
CSETFXUD='CSETFXUD'
CSET21LD='CSET21LD'
CSETF21L='CSETF21L'
WKPLACE='WKPLACE'
READ2='READ2'
PENOS2='PENOS2'
PENBASE='PENBASE'
LAPS='LAPS'
TCPIP='TCPIP'
SBL='SBL'
NSC='NSC'
DCE='DCE'
COM8SDD='COM8SDD'
COMMPASS='COMMPASS'
WF2FIX21='WF2FIX21'
PAB2='PAB2'


Select
when Ctl.!ProgName = SSND then do
say 'Ŀ'
say '                                                                        '
say '      To install Boca Soft System Sounds,                               '
say '      please change the PATH field on the install panel to              '
say '               \MULTIMED\SSND                                           '
say '      by using the .. entry in the Directory field.                     '
say '      Select the INSTALL push button after highlighting all products.   '
say '                                                                        '
say ''
pause
Ctl.!RunProgName
End

when Ctl.!ProgName = MMPM21TK Then do
say 'Ŀ'
say '                                                                        '
say '      To install the OS/2 Multimedia Toolkit Version 1.1,               '
say '      please change the PATH field on the install panel to              '
say '               \MULTIMED\MMPM21TK                                       '
say '      by using the .. entry in the Directory field.                     '
say '      Select the INSTALL push button after highlighting all products.   '
say '                                                                        '
say ''
pause
Ctl.!RunProgName
End

when Ctl.!ProgName = LAPS then do
say 'Ŀ'
say '                                                                        '
say '                LAN Adapter and Protocol Service                        '
say '                                                                        '
say ''
pause
'@cd ..\comm\tcpip\laps'
Ctl.!RunProgName
'@cd ..\..\..\install'
End

when Ctl.!ProgName = TCPIP Then do
say 'Ŀ'
say '                                                                        '
say '      Please ensure that LAPS has been installed first                  '
say '                                                                        '
say '      before proceeding with TCPIP installation,                        '
say '      please refer to the READ.ME file on the                           '
say '            \COMM\TCPIP\TCPIP directory                                 '
say '                                                                        '
say ''
pause

'@cd ..\comm\tcpip\tcpip'
Ctl.!RunProgName
'@cd ..\..\..\install'
End

when Ctl.!ProgName = PENOS2 Then do
say 'Ŀ'
say '                                                                        '
say '            This step will install the Pen OS/2 Tool Kit                '
say '                                                                        '
say ''
pause

'@cd ..\devtools\penos2'
Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = PENBASE Then do
say 'Ŀ'
say '                                                                        '
say '            This step will install the Pen for OS/2 Base                '
say '                                                                        '
say ''
pause

'@cd ..\devtools\penbase'
Ctl.!RunProgName
'@cd ..\..\install'
End



when Ctl.!ProgName = CSETFXCD Then do
do until answer = 'Y'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '               IBM C SET ++ for OS/2 (Corrective Service)                   '
  say '                                                                            '
  say '        The installation process will prompt you for a path, which is       '
  say '          an optional argument. If supplied, the CSD installation           '
  say '        program assumes that IBM C/C++ is installed in that directory.      '
  say '      If not specified, the program searches for the installed version.     '
  say '                                                                            '
  say ''
  say
  say '  Enter a destination for 'Ctl.!ProgName' (optional) or Q to QUIT:'
   tmppath = translate(linein(STDIN))
  if tmppath <> '' then do
     if tmppath = 'Q'
       then call MyExit 300
     if right(tmppath,1) = '\'
       then tmppath = strip(tmppath, 'T', '\')
     if tmppath \= ''
       then do
         say
         say '  You entered 'tmppath' is this correct(Y/N)?'
         answer = translate(linein(STDIN))
         do while answer \= 'Y' & answer \= 'N'
           say beep(450,150)'Enter (Y for yes or N for No)'
           answer = translate(linein(STDIN))
         end /* do */
     end
 end /* if */
 else answer ='Y'
end /* Do */

'@cd ..\services\csetfix\compiler'
if tmppath <>'' then Ctl.!RunProgName tmppath
else Ctl.!RunProgName
'@cd ..\..\..\install'
End

when Ctl.!ProgName = CSETFXLD Then do
do until answer = 'Y'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '               IBM C SET ++ for OS/2 (Corrective Service)                   '
  say '                                                                            '
  say '        The installation process will prompt you for a path, which is       '
  say '          an optional argument. If supplied, the CSD installation           '
  say '        program assumes that IBM C/C++ is installed in that directory.      '
  say '      If not specified, the program searches for the installed version.     '
  say '                                                                            '
  say ''
  say
  say '  Enter a destination for 'Ctl.!ProgName' (optional) or Q to QUIT:'
  tmppath = translate(linein(STDIN))
  if tmppath <> '' then do
     if tmppath = 'Q'
       then call MyExit 300
     if right(tmppath,1) = '\'
       then tmppath = strip(tmppath, 'T', '\')
     if tmppath \= ''
       then do
         say
         say '  You entered 'tmppath' is this correct(Y/N)?'
         answer = translate(linein(STDIN))
         do while answer \= 'Y' & answer \= 'N'
           say beep(450,150)'Enter (Y for yes or N for No)'
           answer = translate(linein(STDIN))
         end /* do */
     end
 end /* if */
 else answer ='Y'
end /* Do */

'@cd ..\services\csetfix\clslib20'
if tmppath <>'' then Ctl.!RunProgName tmppath
else Ctl.!RunProgName
'@cd ..\..\..\install'
End



when Ctl.!ProgName = CSET21LD Then do
do until answer = 'Y'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '               IBM C SET ++ for OS/2 (Corrective Service)                   '
  say '                                                                            '
  say '        The installation process will prompt you for a path, which is       '
  say '          an optional argument. If supplied, the CSD installation           '
  say '        program assumes that IBM C/C++ is installed in that directory.      '
  say '      If not specified, the program searches for the installed version.     '
  say '                                                                            '
  say ''
  say
  say '  Enter a destination for 'Ctl.!ProgName' (optional) or Q to QUIT:'
  tmppath = translate(linein(STDIN))
  if tmppath <> '' then do
     if tmppath = 'Q'
       then call MyExit 300
     if right(tmppath,1) = '\'
       then tmppath = strip(tmppath, 'T', '\')
     if tmppath \= ''
       then do
         say
         say '  You entered 'tmppath' is this correct(Y/N)?'
         answer = translate(linein(STDIN))
         do while answer \= 'Y' & answer \= 'N'
           say beep(450,150)'Enter (Y for yes or N for No)'
           answer = translate(linein(STDIN))
         end /* do */
     end
 end /* if */
 else answer ='Y'
end /* Do */

'@cd ..\services\csetfix\clslib21'
if tmppath <>'' then Ctl.!RunProgName tmppath
else Ctl.!RunProgName
'@cd ..\..\..\install'
End


when Ctl.!ProgName = CSETFXUD Then do
do until answer = 'Y'
  say
  say 'Ŀ'
  say '                       The Developer Connection                             '
  say '               IBM C SET ++ for OS/2 (Corrective Service)                   '
  say '                                                                            '
  say '        The installation process will prompt you for a path, which is       '
  say '          an optional argument. If supplied, the CSD installation           '
  say '        program assumes that IBM C/C++ is installed in that directory.      '
  say '      If not specified, the program searches for the installed version.     '
  say '                                                                            '
  say ''
  say
  say '  Enter a destination for 'Ctl.!ProgName' (optional) or Q to QUIT:'
  tmppath = translate(linein(STDIN))
  if tmppath <> '' then do
     if tmppath = 'Q'
       then call MyExit 300
     if right(tmppath,1) = '\'
       then tmppath = strip(tmppath, 'T', '\')
     if tmppath \= ''
       then do
         say
         say '  You entered 'tmppath' is this correct(Y/N)?'
         answer = translate(linein(STDIN))
         do while answer \= 'Y' & answer \= 'N'
           say beep(450,150)'Enter (Y for yes or N for No)'
           answer = translate(linein(STDIN))
         end /* do */
     end
 end /* if */
 else answer ='Y'
end /* Do */

'@cd ..\services\csetfix\utility'
if tmppath <>'' then Ctl.!RunProgName tmppath
else Ctl.!RunProgName
'@cd ..\..\..\install'
End

when Ctl.!ProgName = CSETFIXC Then do
'@cd ..\services\csetfix\compiler'
Ctl.!RunProgName 'a:'
'@cd ..\..\..\install'
End

when Ctl.!ProgName = CSETFIXL Then do
'@cd ..\services\csetfix\clslib20'
Ctl.!RunProgName 'a:'
'@cd ..\..\..\install'
End

when Ctl.!ProgName = CSETF21L Then do
'@cd ..\services\csetfix\clslib21'
Ctl.!RunProgName 'a:'
'@cd ..\..\..\install'
End

when Ctl.!ProgName = CSETFIXU Then do
'@cd ..\services\csetfix\utility'
Ctl.!RunProgName 'a:'
'@cd ..\..\..\install'
End

when Ctl.!ProgName = SBL Then do
'@cd ..\devtools\sbl\sbleval'
'@call 'Ctl.!RunProgName
'@cd ..\..\..\install'
End

when Ctl.!ProgName = NSC Then do
'@cd ..\comm\nsc'
'@call 'Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = COM8SDD Then do
'@cd ..\devtools\com8sdd'
'@call 'Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = DCE Then do
'@cd ..\comm\dce'
'@call 'Ctl.!RunProgName
'@cd ..\..\install'
End


when Ctl.!ProgName = WF2FIX21 Then do
say 'Ŀ'
say '                                                                        '
say '      This will install the CSD1 fixes to your system                   '
say '                                                                        '
say '      For more information, please refer to the README                  '
say '      file on the SERVICES\WF2FIX21 directory.                          '
say '                                                                        '
say ''
pause
'@cd ..\services\wf2fix21'
Ctl.!RunProgName
'@cd ..\..\install'
pause
End

when Ctl.!ProgName = COMMPASS Then do
'@cd ..\comm\commpass'
Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = PAB2 Then do
'@cd ..\database\pab2'
Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = WKPLACE Then do
'@cd ..\prodtool\wkplace'
Ctl.!RunProgName
'@cd ..\..\install'
End

when Ctl.!ProgName = READ2 Then do
'@cd ..\books'
Ctl.!RunProgName
'@cd ..\install'
End

when Ctl.!ProgName = REALIZER Then do
Ctl.!RunProgName
End

when Ctl.!ProgName = ULTIMOT then do
say 'Ŀ'
say '                                                                        '
say '      To install the MMPM2 Ultimotion Workshop,                         '
say '      Select the INSTALL push button after highlighting all products.   '
say '      IMPORTANT: After installation, READ THE README FILE (ITEM 10)     '
say '                 TO RENAME ANY OF 6 .INI AND .ADF FILES YOU MAY HAVE.   '
say '                 THIS MUST BE DONE BEFORE YOU REBOOT AND RUN ULTIMOT.   '
say '                                                                        '
say ''
pause
Ctl.!RunProgName
End

Otherwise Do
'@call 'Ctl.!RunProgName
End
End

Resp = rc
if Resp \= 0
  then call MyExit 301
return 0

MyExit: procedure expose (Globals)
parse arg Resp

select
  when Resp = 301
    then do
      call 'MessageBox' Ctl.!ProgName, 'Could not find 'Ctl.!ProgName'.'
    end /* Do */
  when Resp = 302
    then do
      call 'MessageBox' Ctl.!ProgName,'Could not find OS/2 2.0 Boot Drive or CD-ROM path.',
                        'Make sure that INSTALL was run from the drive letter of the CD-ROM.'
    end  /* Do */
  otherwise
    nop
end  /* select */
exit Resp


halt:

call MyExit 2
return
