/***************************************************************************/
/*                                                                         */
/* Copyright (c) 1987  - 1994 IBM Corporation                              */
/*                                                                         */
/* TK21DESK.CMD                Version 1.0                                 */
/*                                                                         */
/* Function:                                                               */
/*      Build the WPS entries for the following products:                  */
/*              Development Tool                                           */
/*              ON-Line Text                                               */
/*              C Samples                                                  */
/*              Updates the CONFIG.SYS                                     */
/* Note    :                                                               */
/*                                                                         */
/* Parameters:                                                             */
/*      None                                                               */
/*                                                                         */
/***************************************************************************/
parse upper arg Ctl.!BDr Ctl.!CDr Ctl.!ProgName Ctl.!Source Ctl.!Destination Ctl.!Options
Trace 'O'
Address CMD
'@ECHO OFF'

/* Initialize */
Call Initialize

bootdrive = Ctl.!BDr
tooldrive = Ctl.!CDr
toolpath = Ctl.!Source

/*****************************************************************************/
/*    Ask User for Toolkit drive if there is no toolkit info in system       */
/*****************************************************************************/

'CLS'
Say "Your OS/2 system is installed on the" bootdrive "drive."
Say " "
Say "The OS/2 Toolkit 2.1 components have been found:"
Say " "
If tooldrive <> '' Then Say "     OS/2 Toolkit 2.1 is in" toolpath
Say " "
Say "This program will now create a folder for OS/2 Toolkit 2.1 and"
Say "its identified components on your desktop."
Say " "
Say "Do you want to continue (Y/N)?"
Parse Upper Pull yesno .
If Substr(yesno,1,1) <> 'Y' Then Call Endit

/*****************************************************************************/
/*        Define & Create the Toolkit Folder for the TOOLKIT 2.0                  */
/*****************************************************************************/

If tooldrive <> '' Then Do
   Call SysCreateObject 'WPFolder', 'ToolKit 2.1','<WP_DESKTOP>','OBJECTID=<TTK_TOOLKIT>;ICONFILE='||toolpath||'\ICON\UTILS.ICO'
/*  Call SysCreateObject 'WPFolder', 'ToolKit','<WP_DESKTOP>','ICONFILE='||toolpath||'\ICON\UTILS.ICO' */

/**************************************************************************/
/* Create the Toolkit Info., Dev. Tool, & Sample Folder for the TOOLKIT 2.1  */
/**************************************************************************/

  Call SysCreateObject 'WPFolder', 'Toolkit Information','<TTK_TOOLKIT>','OBJECTID=<TTK_DEVINFO>;ICONFILE='||toolpath||'\ICON\ICONINFO.ICO'
  Call SysCreateObject 'WPFolder', 'Development Tools','<TTK_TOOLKIT>','OBJECTID=<TTK_DEVTOOLS>;ICONFILE='||toolpath||'\ICON\FXICON.ICO'
  Call SysCreateObject 'WPShadow','Toolkit Readme','<TTK_TOOLKIT>','OBJECTID=<TTK_TKREADME>;ICONFILE='||toolpath||'\;SHADOWID='||toolpath||'\READ.ME'
  Call SysCreateObject 'WPFolder', 'Sample Programs','<TTK_TOOLKIT>','OBJECTID=<TTK_CSAMPLE>;ICONFILE='||toolpath||'\ICON\OSTUTOR.ICO'


/*****************************************************************************/
/*        Create Reference Program ICONs in TOOLKIT Info Folder              */
/*****************************************************************************/

  ret = SysFileTree(toolpath||'\BOOK\REXXAPI.INF', 'file', 'B')

  If file.0 \= 0 Then Do
             Call SysCreateObject 'WPProgram','REXX Reference','<TTK_DEVINFO>','OBJECTID=<TTK_REXXAPI>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=REXXAPI.INF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\IPFC20.INF', 'file', 'B')

  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','IPF Reference','<TTK_DEVINFO>','OBJECTID=<TTK_IPFC20>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=IPFC20.INF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\SOM.INF', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','SOM Reference','<TTK_DEVINFO>','OBJECTID=<TTK_SOMREF>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=SOM.INF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\TOOLINFO.INF', 'file', 'B')
  If file.0 \= 0 Then Do
             Call SysCreateObject 'WPProgram','Tools Reference','<TTK_DEVINFO>','OBJECTID=<TTK_TOOLREF>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=TOOLINFO.INF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\PMFUN.INF', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','PM Reference','<TTK_DEVINFO>','OBJECTID=<TTK_PMREF>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=PMREF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\CPGREF1.INF', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','CP Guide and Reference','<TTK_DEVINFO>','OBJECTID=<TTK_PROGREF20>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=PROGREF20;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\BOOK\KDEBUG.INF', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','Kernel Debug Reference','<TTK_DEVINFO>','OBJECTID=<TTK_KDEBUG>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=KDEBUG.INF;STARTUPDIR='||toolpath||'\BOOK;','R'
  end

  ret = SysFileTree(toolpath||'\OS2BIN\KWIKINF.EXE', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','KwikInf','<TTK_DEVINFO>','OBJECTID=<TTK_KWIKINF>;EXENAME='||toolpath||'\OS2BIN\KWIKINF.EXE;PROGTYPE=PM;STARTUPDIR='||toolpath||'\OS2BIN;','R'
  end

/*****************************************************************************/
/*        Create Sample Program  ICONs in Samples Folder                     */
/*****************************************************************************/

  samples.1  = toolpath||'\C\SAMPLES\WORMS\WORMS.EXE WINDOWABLEVIO; -30;  Mixed Mode Sample ; <TTK_WORMS>'
  samples.2  = toolpath||'\C\SAMPLES\ANIMALS\ANIMALS.CMD WINDOWABLEVIO ;; SOM Inheritance Sample ; <TTK_ANIMALS>'
  samples.3  = toolpath||'\C\SAMPLES\TP\TP.CMD WINDOWABLEVIO ;; SOM Text Processing Sample ; <TTK_TP>'
  samples.4  = toolpath||'\C\SAMPLES\NPIPE\SVRNPIPE.EXE PM ;CLINPIPE.EXE; Tic-Tac-Toe Sample ; <TTK_NPIPE>'
  samples.5  = toolpath||'\C\SAMPLES\DLLAPI\DLLAPI.EXE PM ;;Dynamic Link Library Sample ; <TTK_DLLAPI>'
  samples.6  = toolpath||'\C\SAMPLES\QUEUES\SVRQUEUE.EXE PM ;CLIQUEUE.EXE;Queues Sample ; <TTK_QUEUES>'
  samples.7  = toolpath||'\C\SAMPLES\CLOCK\CLOCK.EXE PM ;;Clock Sample ; <TTK_TKCLOCK>'
  samples.8  = toolpath||'\C\SAMPLES\DRAGDROP\DRAGDROP.EXE PM ;;Dragdrop Sample ; <TTK_DRAGDROP>'
  samples.9  = toolpath||'\C\SAMPLES\STYLE\STYLE.EXE PM ;;Style Sample ; <TTK_STYLE>'
  samples.10 = toolpath||'\C\SAMPLES\SEMAPH\SEMAPH.EXE PM ;;Semaphore Sample ; <TTK_SEMAPH>'
  samples.11 = toolpath||'\C\SAMPLES\IMAGE\IMAGE32.EXE PM ;; Image Sample ; <TTK_IMAGE>'
  samples.12 = toolpath||'\C\SAMPLES\VMM\VMM.EXE PM ;; Virtual Memory Management Sample ; <TTK_VMM>'
  samples.13 = toolpath||'\C\SAMPLES\TEMPLATE\TEMPLATE.EXE PM ;;Application Template Sample ; <TTK_TEMPLATE>'
  samples.14 = toolpath||'\C\SAMPLES\HANOI\HANOI.EXE PM ;; Towers of Hanoi Sample ; <TTK_HANOI>'
  samples.15 = toolpath||'\C\SAMPLES\JIGSAW\JIGSAW.EXE PM ;; Jigsaw Puzzle Sample ; <TTK_TKJIGSAW>'
  samples.16 = toolpath||'\C\SAMPLES\EAS\EAS.EXE PM ;; Edit Extended Attributes Sample ; <TTK_EAS>'
  samples.17 = toolpath||'\C\SAMPLES\SORT\SORT.EXE PM ;; Sorting Algorithm Sample ; <TTK_SORT>'
  samples.18 = toolpath||'\C\SAMPLES\HELLO\HELLO.EXE PM ;; Standard Window Sample ; <TTK_HELLO>'
  samples.19 = toolpath||'\C\SAMPLES\GRAPHIC\GRAPHIC.EXE PM ;; Retained Graphics Sample ; <TTK_GRAPHIC>'
  samples.20 = toolpath||'\C\SAMPLES\DIALOG\DIALOG.EXE PM ;; Introductory Dialog Box Sample ; <TTK_DIALOG>'
  samples.21 = toolpath||'\C\SAMPLES\CLIPBRD\CLIPBRD.EXE PM ;; Clipboard Sample ; <TTK_CLIPBRD>'
  samples.22 = toolpath||'\C\SAMPLES\PRINT\PRTSAMP.EXE PM ;; Print Sample ; <TTK_PRINT>'
  samples.23 = toolpath||'\REXX\SAMPLES\CALLREXX\CALLREXX.CMD WINDOWABLEVIO ;; REXX Interpreter Invocation Sample ; <TTK_CALLREXX>'
  samples.24 = toolpath||'\REXX\SAMPLES\DEVINFO\DEVINFO.CMD WINDOWABLEVIO ;; REXX Variable Pool Interface Sample ; <TTK_RXTKINFO>'
  samples.25 = toolpath||'\REXX\SAMPLES\REXXUTIL\REXXUDEM.CMD WINDOWABLEVIO ;; Presentation Manager REXX Interface Sample ; <TTK_PMREXX>'
  samples.26 = toolpath||'\REXX\SAMPLES\REXXUTIL\REXXUDEM.CMD WINDOWABLEVIO ;; REXX Utility Functions Sample ; <TTK_REXXUTIL>'
  samples.27 = toolpath||'\REXX\SAMPLES\RXMACDLL\RXMACDLL.CMD WINDOWABLEVIO ;; External Functions in REXX Macrospace Sample ; <TTK_RXMACDLL>'
  samples.0  = 27

  Do i = 1 to samples.0
    Parse Var samples.i program type ';' parms ';' title ';' objid
    program = Strip(program)
    type = Strip(title)
    parms = Strip(parms)
    title = Strip(title)
    objid = Strip(objid)

    If parms = '' Then Do
      Call SysCreateObject 'WPProgram',title,'<TTK_CSAMPLE>','OBJECTID='||objid||';EXENAME='||program||';PROGTYPE='||type||';STARTUPDIR='||Filespec('D',program)||Substr(Filespec('P',program),1,Length(Filespec('P',program))-1)||';','R'
    End
    Else Do
Call SysCreateObject 'WPProgram',title,'<TTK_CSAMPLE>','OBJECTID='||objid||';EXENAME='||program||';PROGTYPE='||type||';PARAMETERS='||parms||';STARTUPDIR='||Filespec('D',program)||Substr(Filespec('P',program),1,Length(Filespec('P',program))-1)||';','R'
     End
  End


  Call SysCreateObject 'WPProgram','Palette Sample','<TTK_CSAMPLE>','OBJECTID=<TTK_PALETTE>;EXENAME='||toolpath||'\C\SAMPLES\PALETTE\PALETTE.EXE;PROGTYPE=PM;STARTUPDIR='||toolpath||'\C\SAMPLES\PALETTE;','R'

  Call SysCreateObject 'WPProgram','Information Presentation Facility Sample','<TTK_CSAMPLE>','OBJECTID=<TTK_IPF>;EXENAME='||bootdrive||'\OS2\VIEW.EXE;PROGTYPE=PM;PARAMETERS=IPF.INF;STARTUPDIR='||toolpath||'\C\SAMPLES\IPF;','R'


  Call SysRegisterObjectClass 'Car', toolpath||'\C\SAMPLES\WPCAR\CAR.DLL'
  Call SysCreateObject 'Car', 'WP Car Sample','<TTK_CSAMPLE>','OBJECTID=<TTK_CAR>'


/*****************************************************************************/
/*        Create Utility ICONs                                               */
/*****************************************************************************/

  ret = SysFileTree(toolpath||'\OS2BIN\DLGEDIT.EXE', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','Dialog Editor','<TTK_DEVTOOLS>','OBJECTID=<TTK_DLGEDIT>;EXENAME='||toolpath||'\OS2BIN\DLGEDIT.EXE;PROGTYPE=PM;STARTUPDIR='||bootdrive||'\;','R'
  end

  ret = SysFileTree(toolpath||'\OS2BIN\FONTEDIT.EXE', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','Font Editor','<TTK_DEVTOOLS>','OBJECTID=<TTK_FONTEDIT>;EXENAME='||toolpath||'\OS2BIN\FONTEDIT.EXE;PROGTYPE=PM;STARTUPDIR='||bootdrive||'\;','R'
  end

  ret = SysFileTree(toolpath||'\OS2BIN\ICONEDIT.EXE', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysCreateObject 'WPProgram','Icon Editor','<TTK_DEVTOOLS>','OBJECTID=<TTK_ICONEDIT>;EXENAME='||toolpath||'\OS2BIN\ICONEDIT.EXE;PROGTYPE=PM;STARTUPDIR='||bootdrive||'\;','R'
  end

  ret = SysFileTree(toolpath||'\DLL\WPCLSLST.DLL', 'file', 'B')
  If file.0 \= 0 Then Do
     Call SysRegisterObjectClass 'WPKlist', toolpath||'\DLL\WPCLSLST.DLL'
     Call SysCreateObject 'WPKlist', 'WP Class List','<TTK_DEVTOOLS>','OBJECTID=<TTK_CLIST>'
  end

/*****************************************************************************/
/*        Update the CONFIG.SYS                                              */
/*****************************************************************************/
  Call Tk20ChgConfig

End


/****************/
/* Exit program */
/****************/
Endit:

call 'CaddComplete' 12
call 'CaddExit'

Exit 0

/***************************/
/* Change the CONFIG.SYS   */
/***************************/

Tk20ChgConfig:   /* change the config.sys file for Toolkit 2.0 */

'@cls'
response=''

/* Say '    Do you want to update 'bootdrive'\CONFIG.SYS?(Y/N)'
  Parse Upper Pull response
  If response <> 'N' Then Do
*/
     Say '    Updating CONFIG.SYS...........................          '
     Say ' '
     Say '    The old 'bootdrive'\CONFIG.SYS will be renamed 'bootdrive'\CONFIG.TKT.'
     Say ' '
     Say '    Shutdown and restart your system for these changes to take effect.'
     Say ' '

/*  End
  Else
     return 0
*/

oldconfig=bootdrive'\CONFIG.SYS'
newconfig=bootdrive'\CONFIG.TKT'
tmpconfig=bootdrive'\TMP.SYS'

os2progref20='SET PROGREF20'
pmref='SET PMREF'
helpndx='SET HELPNDX'
ipfc='SET IPFC'

progref20flag=0
pmrefflag=0
helpndxflag=0
ipfcflag=0

/* get the portion of pathspec without the [drive]: */
pathonly = right(toolpath, length(toolpath)-2)

/*
 * read the file one line at a time, and write it all out, making
 * changes accordingly - need to change path, libpath, help, bookshelf
 * ipfc, include, lib
 */

'@del 'newconfig ' 2>nul >nul'

Do while lines(oldconfig)
    inline=linein(oldconfig)

    /******************************************/
    /* parse the line into variable and value */
    /******************************************/

    parse value inline with os2var '=' os2value

    /********************************************************/
    /* translate the variable into uppercase for comparison */
    /********************************************************/

    os2var=translate(os2var)
    Select
        /********************************************************/
        /*          For PROGREF20                               */
        /********************************************************/

        when os2var=os2progref20 Then Do
            progref20flag=1

            tk20line='SET PROGREF20=CPGREF1.INF+CPGREF2.INF+CPGREF3.INF'

            /*
             * write the line out to the new config file
             */

            result=lineout(newconfig, tk20line)
            If result=1 Then Do
                writeerror()
                return 1
            End
         End
        when os2var=pmref Then Do
            pmrefflag=1

            tk20line=inline

            /*
             * write the line out to the new config file
             */

            result=lineout(newconfig, tk20line)
            If result=1 Then Do
                writeerror()
                return 1
            End
         End
        when os2var=helpndx Then Do
            helpndxflag=1

            tk20line=inline

            /*
             * write the line out to the new config file
             */

            result=lineout(newconfig, tk20line)
            If result=1 Then Do
                writeerror()
                return 1
            End
         End
        when os2var=ipfc Then Do
            ipfcflag=1

            tk20line=inline

            /*
             * write the line out to the new config file
             */

            result=lineout(newconfig, tk20line)
            If result=1 Then Do
                writeerror()
                return 1
            End
         End
        otherwise Do
            /*
             * write the line out to the new config file
             */

            result=lineout(newconfig, inline)
            If result=1 Then Do
                writeerror()
                return 1
            End
        End  /* when */
    End  /* select */

End /* Do */

/******************************************************************/
/* if there was no SET PROGREF20 variable set in CONFIG.SYS, Then */
/* put New env. variables                                         */
/******************************************************************/

If progref20flag=0 Then Do

    tk20line='SET PROGREF20=CPGREF1.INF+CPGREF2.INF+CPGREF3.INF'

    /*
     * write the line out to the new config file
     */

    result=lineout(newconfig, tk20line)
    If result=1 Then Do
        writeerror()
        return 1
    End
End

/******************************************************************/
/* if there was no SET PROGREF20 variable set in CONFIG.SYS, Then */
/* put New env. variables                                         */
/******************************************************************/

If pmrefflag=0 Then Do

    tk20line='SET PMREF=PMFUN.INF+PMGPI.INF+PMHOK.INF+PMMSG.INF+PMREL.INF+PMWIN.INF+PMWKP.INF '

    /*
     * write the line out to the new config file
     */

    result=lineout(newconfig, tk20line)
    If result=1 Then Do
        writeerror()
        return 1
    End
End

/******************************************************************/
/* if there was no SET PROGREF20 variable set in CONFIG.SYS, Then */
/* put New env. variables                                         */
/******************************************************************/

If helpndxflag=0 Then Do

    tk20line='SET HELPNDX=EPMKWHLP.NDX'

    /*
     * write the line out to the new config file
     */

    result=lineout(newconfig, tk20line)
    If result=1 Then Do
        writeerror()
        return 1
    End
End
/******************************************************************/
/* if there was no SET PROGREF20 variable set in CONFIG.SYS, Then */
/* put New env. variables                                         */
/******************************************************************/

If ipfcflag=0 Then Do

    tk20line='SET IPFC='||toolpath||'\IPFC;'

    /*
     * write the line out to the new config file
     */

    result=lineout(newconfig, tk20line)
    If result=1 Then Do
        writeerror()
        return 1
    End
End
/*********************/
/* close the files   */
/*********************/

result=lineout(newconfig)
result=lineout(oldconfig)

/******************************************************************/
/* Copy created file(CONFIG.TKT) to temporary file(TMP.SYS),      */
/* copy original file(CONFIG.SYS) to new file(CONFIG.TKT),        */
/* and copy temporary file(TMP.SYS) to original file(CONFIG.SYS). */
/******************************************************************/

'@copy 'oldconfig' 'tmpconfig' 2>nul >nul'

'@copy 'newconfig' 'oldconfig' 2>nul >nul'

'@copy 'tmpconfig' 'newconfig' 2>nul >nul'

'@del 'tmpconfig' 2>nul >nul'
/******************************************************************/
/*  Finished the Update                                           */
/******************************************************************/

Say ' '
Say '               'bootdrive'\CONFIG.SYS updated succesfully.'
Say ' '

return 0


writeerror:         /* display a write error to the screen */

'@cls'
Say ' '
Say ' '
Say '                       *****  ERROR  *****'
Say ' '
Say '               An error occured while attempting to write the '
Say '               'bootdrive'\CONFIG.SYS file.  Check the available disk'
Say '               disk space on the current drive and retry the'
Say '               install process.'
Say ' '
pause

return 0

/********************************/
/* Notify user in case of error */
/********************************/
Telluser: Procedure
Parse source . . tell_name .
tell_name = Filespec('name',tell_name)
Parse Upper Var tell_name tell_name '.' .
ulogfile = tell_name
If Arg(2,'e') = 0 Then Do
  Say tell_name||':' Date('U') Time() Arg(1)
End
Else Do
  If Arg(2) = 0 Then Do
    Say tell_name||':' Date('U') Time() Arg(1)
  End
  Else Do
    Say Copies(' ',15+Length(tell_name)) Arg(1)
  End
End
Return 0

Initialize:
/*******************************************************************/
/* Load required REXXUTIL (part of 2.0) utilites and the required  */
/* RXUTILS (part of CORE and avail on OS2TOOLS) utilites           */
/*******************************************************************/
CurDir = directory()
call directory Ctl.!CDr'INSTALL'
call Rxfuncadd 'CADDINIT', 'RXCADD', 'CADDINIT'
signal on syntax
ver = 'CAddInit'()
signal off syntax
if abbrev(ver, 'ERROR:')
  then call syntax
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
return
